;чтобы не тянуть include-файл
.list
.equ    DDRB= 0x17
.equ    PORTB= 0x18
.equ    RAMEND= 0x009f
.equ    SPL= 0x3d
.equ    TCCR0B= 0x33
.equ    TIMSK0= 0x39
.equ    SREG= 0x3f

;это лишь демонстрация, потому регистров и не жалеем
.def    temp=R16
.def    lev_ch1=R17
.def    lev_ch2=R18
.def    lev_ch3=R19
.def    buf_lev_ch1=R13
.def    buf_lev_ch2=R14
.def    buf_lev_ch3=R15
.def    counter=R20
.def    delay0=R21
.def    delay1=R22
.def    delay2=R23

.cseg
.org 0
;таблица прерываний из даташита:
rjmp RESET                  ; Reset Handler
rjmp EXT_INT0               ; IRQ0 Handler
rjmp PIN_CHG_IRQ            ; PCINT0 Handler
rjmp TIM0_OVF               ; Timer0 Overflow Handler
rjmp EE_RDY                 ; EEPROM Ready Handler
rjmp ANA_COMP               ; Analog Comparator Handler
rjmp TIM0_COMPA             ; Timer0 CompareA Handler
rjmp TIM0_COMPB             ; Timer0 CompareB Handler
rjmp WATCHDOG               ; Watchdog Interrupt Handler
rjmp ADC_IRQ                ; ADC Conversion Handler

;RESET:
EXT_INT0:
PIN_CHG_IRQ:
;TIM0_OVF:
EE_RDY:
ANA_COMP:
TIM0_COMPA:
TIM0_COMPB:
WATCHDOG:
ADC_IRQ:

reti

RESET:
  ldi temp,0b00000111 ; назначаем PortB пины PB0, PB1
  out DDRB,temp       ; и PB2 выходами

  ldi temp,0          ; выставляем все выводы
  out PORTB,temp      ; PortB в 0 
  ldi temp,low(RAMEND) ; инициализация
  out SPL,temp         ; стека

  ldi temp,0b00000001 ; вкл. таймер
  out TCCR0B,temp     ; без делителя

  ldi temp,0b00000010 ; вкл. прерывание
  out TIMSK0,temp     ; таймера по переполнению

  sei                 ; разрешить прерывания

  ldi lev_ch1,0
  ldi lev_ch2,64
  ldi lev_ch3,128

start_pwm:          ; бесконечная шарманка
  inc lev_ch1       ; увеличиваем значения
  inc lev_ch2       ; длительности ШИМ
  inc lev_ch3       ; по всем каналам
  rcall delay       ; небольшая пауза для плавности
  rjmp start_pwm

delay:           ; процедура задержки
  ldi delay2,$01  ; выставляем число,
  ldi delay1,$77  ; до скольки считать
  ldi delay0,$00  ; $017700 - даст задержку в 50мс
  loop:
    subi delay0,1 ; считаем
    sbci delay1,0 ; считаем
    sbci delay2,0 ; считаем
    brcc loop
 ret

TIM0_OVF:       ; обработка прерывания таймера 
  push temp     ; на всякий пожарный сохраняем
  in temp,SREG  ; temp и SREG в стеке
  push temp

  inc counter   ; счетчик перехода таймера через 0

  cpi counter,0 ; если не 0, то проверяем
  brne ch1_off  ; не надо ли чего погасить

  mov buf_lev_ch1,lev_ch1 ; если счетчик 0
  mov buf_lev_ch2,lev_ch2 ; то задаем новые
  mov buf_lev_ch3,lev_ch3 ; значения длительности ШИМ каналов

  ldi temp,0b00000111 ; включить все
  out PORTB,temp      ; три выхода

ch1_off:                 ; а не погасить ли нам
  cp counter,buf_lev_ch1 ; первый канал?
  brne ch2_off           ; нет, рано - проверяем второй
  cbi PORTB,0            ; да погасить

ch2_off:                 ; а не погасить ли нам
  cp counter,buf_lev_ch2 ; второй канал?
  brne ch3_off            ; нет, рано - проверяем третий
  cbi PORTB,1            ; да погасить

ch3_off:                 ; а не погасить ли нам
  cp counter,buf_lev_ch3 ; третий канал?
  brne irq_end           ; нет, рано - двигаемся к выходу из прерывания
  cbi PORTB,2            ; да, погасить

irq_end:         ; достаем из стека
  pop temp       ; SREG и temp
  out SREG,temp
  pop temp

reti             ;выходим из прерывания
